#ifndef __NET_NET_H__
#define __NET_NET_H__

#include "config.h"
#include "phash.h"
#include <assert.h>

#define PORT 16235

#define NEW(type) 		(type*)malloc(sizeof(type))
#define NEW_ARRAY(type, n)	(type*)malloc(sizeof(type) * (n))

#define halt() assert(0)

struct pkt_entry {
	struct pkt_entry *next;
	char *name;
	char *string;
	int number;
};

int inet_connect(const char *host, int port);

/* packet.c */
void pkt_add_string(struct phash *h, const char *name, const char *data);
void pkt_add_int(struct phash *h, const char *name, int data);
int pkt_send(int fd, struct phash *h);
struct phash *pkt_recv(int fd);
void pkt_md5(const char *string, char *junk);
void pkt_free(struct phash *pkt);
const char *pkt_get_string(struct phash *h, const char *name, const char *def);
int pkt_get_int(struct phash *h, const char *name, int def);

/* hey! i don't want my program to coredump on xfree(0) ! */
void *ymalloc(int);
void yfree(void*);
char *ystrdup(const char*);

#endif /* __NET_NET_H__ */
