<?php
/** GNU license v.2.
	Autor: Pawel Kolodziej <pawelk@pld.org.pl>
	(c) Pawel Kolodziej 2001
*/

require("xtpl.php");
require("DBmop.php");

$xtpl = new XTemplate("_xtpl/stats.xtpl");
$db = new DBmop();

function nostats()
{
	global $xtpl;
	$xtpl->parse("main.error_nostats");
	$xtpl->parse("main");
	$xtpl->out("main");
	exit();
}

/* generuje statystyke zbiorcza  -- bez uwzglednienia "srodowiska"*/
function stat_summary($fId, $fName, $env)
{
	global $xtpl, $db;
	$xtpl->assign( "FEATURE", $fName );
	$db->query("SELECT count(opinion.id), mark FROM report, opinion WHERE ".
			"report.id in (SELECT id FROM tmp_rep) AND ".
			"opinion.id_report = report.id AND ".
			"opinion.id_feature = '".$fId."' ".
			"GROUP BY mark");
	$marks["0"] = $marks["3"] = $marks["7"] = $marks["10"] = "0";
	while($db->next_record()){
		$marks[$db->f("mark")] = $db->f("count");
	}
	$xtpl->assign("M0",  $marks["0"]);
	$xtpl->assign("M3",  $marks["3"]);
	$xtpl->assign("M7",  $marks["7"]);
	$xtpl->assign("M10",  $marks["10"]);
	$xtpl->parse("main.stat_sum.feature");
	
}

/** generuje statystyke biarac pod uwage tylko jedna wlasnosc */
function stat_feature($fId, $fName, $env)
{
	global $db, $xtpl, $evrcmpFun ;
	$db->query("SELECT * from tmp_rep");
/*	while($db->next_record()){
		echo("RAPORT : ".$db->f("id")."<br>");
	}
	echo ("koniec raportow");
*/
	reset($env);
	while( list($key, $en) = each($env) ){
		$eEvr = $en["evr"];
		$eName = $en["name"];
		$db->query("SELECT count(opinion.id), mark, ".
			$evrcmpFun."(enviroment.evr,'".$eEvr."') ".
			"FROM opinion, report, enviroment, package ".
			"WHERE report.id in (SELECT id FROM tmp_rep) AND ".
			"opinion.id_report = report.id AND ".
			"opinion.id_feature = '".$fId."' AND ".
			"enviroment.id_report = report.id AND ".
			"enviroment.id_package = package.id AND ".
			"package.name = '".$eName."' ".
			"GROUP BY mark,".$evrcmpFun."(enviroment.evr, '".$eEvr.
			"') ");
		
		for($i=0;$i<100; $i++)
			for($j=-1;$j<=2;$j++)
				$marks["$i"]["$j"] = " - ";
	
		while($db->next_record()){
			$mark = $db->f("mark");
			$cnt  = $db->f("count");
			$evrcmp = $db->f($evrcmpFun);
			
			$marks[$mark][$evrcmp] = $cnt;
		}
		$xtpl->assign("ENV_NAME", $eName);
		$xtpl->assign("M0O"  , $marks["0"]["-1"] );
		$xtpl->assign("M3O"  , $marks["3"]["-1"] );
		$xtpl->assign("M7O"  , $marks["7"]["-1"] );
		$xtpl->assign("M10O" , $marks["10"]["-1"] );	
		$xtpl->assign("M0E"  , $marks["0"]["0"] );
		$xtpl->assign("M3E"  , $marks["3"]["0"] );
		$xtpl->assign("M7E"  , $marks["7"]["0"] );
		$xtpl->assign("M10E" , $marks["10"]["0"] );
		$xtpl->assign("M0N"  , $marks["0"]["1"] );
		$xtpl->assign("M3N"  , $marks["3"]["1"] );
		$xtpl->assign("M7N"  , $marks["7"]["1"] );
		$xtpl->assign("M10N" , $marks["10"]["1"] ); 
		$xtpl->parse("main.stat.feature.row"); 
	}
	$xtpl->assign("FEATURE", $fName);
	$xtpl->parse("main.stat.feature");
}


$urlctx=stripslashes($urlctx);
$ctx = unserialize( $urlctx) ;

if( empty($ctx) || empty($ctx["pkg"]) || empty($ctx["evr"]) ){
	$xtpl->parse("main.error_var");
	$xtpl->parse("main");
	$xtpl->out("main");
	exit();
}

/* if user selected some url from "configure" section handle it */

if(empty($ctx["arch"]))
	$ctx["arch"] = array();

if($action == "add_arch"){
	array_push( $ctx["arch"], $arch_name );
}

if($action == "del_arch"){
	reset( $ctx["arch"] );
	$new_arch = array();
	while( list($key, $val) = each( $ctx["arch"] )){
		if($val != $arch_name){
			array_push( $new_arch, $val);
		}
	}
	$ctx["arch"] = $new_arch;
}

if($action == "with_rev"){
	$ctx["with_rev"] = $with_rev;
}

if($action == "change_evr"){
	$ctx["evr"] = $new_evr;
}

$urlctx  = urlencode( serialize( $ctx ) );
$urlBase = "stats.php?urlctx=".$urlctx."&";

/* Now parse "configure" section */
$xtpl->assign("PKG_NAME", $ctx["pkg"]);
$xtpl->assign("PKG_EVR" , $ctx["evr"]);

$archStr ="";
reset( $ctx["arch"] );
while ( list($key, $val) = each( $ctx["arch"] ) )
	$archStr.=" ".$val;
$xtpl->assign("PKG_ARCHS", $archStr);

/*!!! zalozenie ze w ctx[arch] nie bedzie arhcitektor ktorych nie ma w bazie 
  (nie da sie ich usunac)
*/
$db->query("SELECT DISTINCT arch.name FROM arch,package,report WHERE ".
	"package.name='".$ctx["pkg"]."' AND ".
	"package.id = report.id_package AND ".
	"report.id_arch = arch.id");
while($db->next_record()){
	$found = 0;
	reset( $ctx["arch"] );
	while( list($key, $val) = each( $ctx["arch"] ))
		if( $val == $db->f("name") )
			$found =1;
	$xtpl->assign("ARCH", $db->f("name"));
	if( $found == 1){
		if(count($ctx["arch"]) > 1 ){
			$xtpl->assign("URL",$urlBase.
			"action=del_arch&arch_name=".$db->f("name"));
			$xtpl->parse("main.config.del_arch");
		}
	}else{
		$xtpl->assign("URL",$urlBase."action=add_arch&arch_name=".
			$db->f("name"));
		$xtpl->parse("main.config.add_arch");
	}
}

if( $ctx["with_rev"] == 1 ){
	$xtpl->assign("URL", $urlBase."action=with_rev&with_rev=0");
	$xtpl->parse("main.config.without_rev");
}else{
	$xtpl->assign("URL", $urlBase."action=with_rev&with_rev=1");
	$xtpl->parse("main.config.with_rev");
}

$db->query("SELECT DISTINCT evr FROM report, package WHERE ".
		"package.name = '".$ctx["pkg"]."' AND ".
		"package.id = report.id_package ORDER BY evr");
while($db->next_record()){
	$xtpl->assign("EVR", $db->f("evr"));
	$xtpl->assign("URL", $urlBase."action=change_evr&new_evr=".
			$db->f("evr") );
	$xtpl->parse("main.config.chg_evr");
}

$xtpl->parse("main.config");


if($ctx["with_rev"] == 1)
	$evrcmpFun="evrcmp";
else
	$evrcmpFun="evcmp";

/* Now its high time to generate some statistic */

$db->query("SELECT id FROM package WHERE name ='".$ctx["pkg"]."'");
if( ! $db->next_record() ){
	nostats();
}

$pkgId = $db->f("id");

/* get lists of features for this package */
$fetaures = array();
$db->query("SELECT id, name FROM package_feature, feature WHERE ".
		"id_package = '".$pkgId."' AND ".
		"id = id_feature");
while($db->next_record() ){
	$features[$db->f("id")] = $db->f("name");
}

/* Get archs ID */
$archs = " '1' = '0' ";
reset($ctx["arch"]);
while( list($key, $val) = each($ctx["arch"]) ){
	$archs .=  " OR name = '".$val."' ";
}
$db->query("SELECT id FROM arch WHERE ".$archs);
$archsIds = " '1' = '0' ";
while( $db->next_record() ){
	$archsIds .= " OR id_arch = '".$db->f("id")."' ";
}
/* get report's ids */
/*
print("pkgid = ".$pkgId."<br>");
print("archsids =".$archsIds."<br>");
print("archs = ".$archs."<br>");
*/
$reports = array();
$db->query("BEGIN");
$db->query("SELECT id INTO tmp_rep FROM report WHERE ".
		"id_package = '".$pkgId."' AND ".
		"( ".$archsIds." ) AND evrcmp(evr,'".$ctx["evr"]."')=0");
if(count($features) == 0){
	nostats();
}

reset($features);
while(list($fId, $fName) = each($features)){
	stat_feature($fId, $fName, $ctx["env"] );
	stat_summary($fId, $fName, $ctx["env"] );
}

$xtpl->parse("main.stat");
$xtpl->parse("main.stat_sum");

$db->query("DROP TABLE tmp_rep");
$db->query("ROLLBACK");


$xtpl->parse("main");
$xtpl->out("main");
print "END";

?>
